/*
 * Classe implantant le rond du morpion.
 */
package jeu.morpion;

import jeu.*;

/**
 * La pièce 'O' du morpion
 * @author courtieu
 */
public class Rond implements Piece {

    public Rond() {
    }

    public Character getName(){
        return 'O';
    }

    public java.awt.Color[][] getIcon(java.awt.Color fond) {
        java.awt.Color[][] t = {null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null};
        java.awt.Color O = java.awt.Color.WHITE;
        java.awt.Color x = fond;
        java.awt.Color[] t0 = {x, x, x, x, x, x, x, x, x, x, x, x, x, x, x, x};
        java.awt.Color[] t1 = {x, x, x, x, x, x, O, O, O, O, x, x, x, x, x, x};
        java.awt.Color[] t2 = {x, x, x, x, x, O, O, O, O, O, O, x, x, x, x, x};
        java.awt.Color[] t3 = {x, x, x, x, O, O, O, x, x, O, O, O, x, x, x, x};
        java.awt.Color[] t4 = {x, x, x, O, O, O, x, x, x, O, O, O, O, x, x, x};
        java.awt.Color[] t5 = {x, x, x, O, O, O, x, x, x, x, O, O, O, x, x, x};
        java.awt.Color[] t6 = {x, x, O, O, O, x, x, x, x, x, x, O, O, O, x, x};
        java.awt.Color[] t7 = {x, x, O, O, O, x, x, x, x, x, x, O, O, O, x, x};
        java.awt.Color[] t8 = {x, x, O, O, O, x, x, x, x, x, x, O, O, O, x, x};
        java.awt.Color[] t9 = {x, x, O, O, O, x, x, x, x, x, x, O, O, O, x, x};
        java.awt.Color[] t10 = {x, x, x, O, O, O, x, x, x, x, x, O, O, x, x, x};
        java.awt.Color[] t11 = {x, x, x, O, O, O, x, x, x, x, O, O, O, x, x, x};
        java.awt.Color[] t12 = {x, x, x, x, O, O, O, x, x, O, O, O, x, x, x, x};
        java.awt.Color[] t13 = {x, x, x, x, x, O, O, O, O, O, O, x, x, x, x, x};
        java.awt.Color[] t14 = {x, x, x, x, x, x, O, O, O, O, x, x, x, x, x, x};
        java.awt.Color[] t15 = {x, x, x, x, x, x, x, x, x, x, x, x, x, x, x, x};

        t[0] = t0;
        t[1] = t1;
        t[2] = t2;
        t[3] = t3;
        t[4] = t4;
        t[5] = t5;
        t[6] = t6;
        t[7] = t7;
        t[8] = t8;
        t[9] = t9;
        t[10] = t10;
        t[11] = t11;
        t[12] = t12;
        t[13] = t13;
        t[14] = t14;
        t[15] = t15;
        return t;
    }

    /* SOLUTION:// Suggestion: implémenter equals et peut-être toString. */
    // On implémente l'égalité car l'égalité par défaut est incorrecte
    @Override
    public boolean equals(Object o) {
        // self check
        if (this == o) {
            return true;
        }
        // null check
        if (o == null) {
            return false;
        }
        // type check and cast
        if (getClass() != o.getClass()) {
            return false;
        }
        Rond c = (Rond) o;
        // field comparison
        return this.getName() == c.getName();
    }
    @Override
    public String toString(){
        return ""+this.getName();
    }
    /* FIN SOLUTION */
}
